import numpy as np
from shogun import CSVFile
from shogun import EuclideanDistance
from shogun import RealFeatures

f_feats_a = CSVFile("../../data/fm_train_real.dat")
f_feats_b = CSVFile("../../data/fm_test_real.dat")

#![create_features]
features_a = RealFeatures(f_feats_a)
features_b = RealFeatures(f_feats_b)
#![create_features]

#![create_instance]
distance = EuclideanDistance(features_a, features_a)
#![create_instance]

#![extract_distance]
distance_matrix_aa = distance.get_distance_matrix()
#![extract_distance]

#![refresh_distance]
distance.init(features_a, features_b)
#![refresh_distance]

#![extract_sq_distance]
distance.set_disable_sqrt(True)
distance_matrix_ab = distance.get_distance_matrix()
#![extract_sq_distance]
