import numpy as np
from shogun import BoolVector
from shogun import CARTree
from shogun import CSVFile
from shogun import Math
from shogun import MulticlassAccuracy
from shogun import MulticlassLabels
from shogun import PT_MULTICLASS
from shogun import RealFeatures

f_feats_train = CSVFile("../../data/classifier_4class_2d_linear_features_train.dat")
f_feats_test = CSVFile("../../data/classifier_4class_2d_linear_features_test.dat")
f_labels_train = CSVFile("../../data/classifier_4class_2d_linear_labels_train.dat")
f_labels_test = CSVFile("../../data/classifier_4class_2d_linear_labels_test.dat")
Math.init_random(1)

#![create_features]
features_train = RealFeatures(f_feats_train)
features_test = RealFeatures(f_feats_test)
labels_train = MulticlassLabels(f_labels_train)
labels_test = MulticlassLabels(f_labels_test)
#![create_features]

#![set_attribute_types]
ft = np.zeros( (2), dtype='bool')
ft[0] = False
ft[1] = False
#![set_attribute_types]

#![create_instance]
classifier = CARTree(ft, PT_MULTICLASS, 5, True)
classifier.set_labels(labels_train)
#![create_instance]

#![train_and_apply]
classifier.train(features_train)
labels_predict = classifier.apply_multiclass(features_test)
#![train_and_apply]

#![evaluate_accuracy]
eval = MulticlassAccuracy()
accuracy = eval.evaluate(labels_predict, labels_test)
#![evaluate_accuracy]

# integration testing variables
output = labels_predict.get_labels()
