import numpy as np
from shogun import CSVFile
from shogun import EuclideanDistance
from shogun import KNN
from shogun import MulticlassAccuracy
from shogun import MulticlassLabels
from shogun import RealFeatures

f_feats_train = CSVFile("../../data/classifier_4class_2d_linear_features_train.dat")
f_feats_test = CSVFile("../../data/classifier_4class_2d_linear_features_test.dat")
f_labels_train = CSVFile("../../data/classifier_4class_2d_linear_labels_train.dat")
f_labels_test = CSVFile("../../data/classifier_4class_2d_linear_labels_test.dat")

#![create_features]
features_train = RealFeatures(f_feats_train)
features_test = RealFeatures(f_feats_test)
labels_train = MulticlassLabels(f_labels_train)
labels_test = MulticlassLabels(f_labels_test)
#![create_features]

#![choose_distance]
distance = EuclideanDistance(features_train, features_train)
#![choose_distance]

#![create_instance]
k = 3
knn = KNN(k, distance, labels_train)
#![create_instance]

#![train_and_apply]
knn.train()
labels_predict = knn.apply_multiclass(features_test)
#![train_and_apply]

#![evaluate_accuracy]
eval = MulticlassAccuracy()
accuracy = eval.evaluate(labels_predict, labels_test)
#![evaluate_accuracy]

# additional integration testing variables
output = labels_predict.get_labels()
